Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15032)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
   using System.Collections.Generic;
 
@@ -10,6 +9,6 @@
 
   /// <summary>
-  ///     Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
-  ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
+  /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
+  /// The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
@@ -32,5 +31,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.YANK")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.")]
   public class IntegerYankExpression : YankExpression<long> {
     public IntegerYankExpression() { }
@@ -48,5 +50,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class FloatYankExpression : YankExpression<double> {
     public FloatYankExpression() { }
@@ -64,5 +70,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class BooleanYankExpression : YankExpression<bool> {
     public BooleanYankExpression() { }
@@ -80,5 +90,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class NameYankExpression : YankExpression<string> {
     public NameYankExpression() { }
@@ -96,5 +110,10 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.YANK", StackTypes.Integer, execIn: 0)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer,
+    execIn: 0)]
   public class ExecYankExpression : YankExpression<Expression> {
     public ExecYankExpression() { }
@@ -112,5 +131,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class CodeYankExpression : YankExpression<Expression> {
     public CodeYankExpression() { }
@@ -128,5 +151,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class CharYankExpression : YankExpression<char> {
     public CharYankExpression() { }
@@ -144,5 +171,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class StringYankExpression : YankExpression<string> {
     public StringYankExpression() { }
@@ -160,5 +191,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class IntegerVectorYankExpression : YankExpression<IReadOnlyList<long>> {
     public IntegerVectorYankExpression() { }
@@ -176,5 +211,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class FloatVectorYankExpression : YankExpression<IReadOnlyList<double>> {
     public FloatVectorYankExpression() { }
@@ -192,5 +231,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class BooleanVectorYankExpression : YankExpression<IReadOnlyList<bool>> {
     public BooleanVectorYankExpression() { }
@@ -208,5 +251,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].YANK", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].YANK",
+    "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
+    StackTypes.Integer)]
   public class StringVectorYankExpression : YankExpression<IReadOnlyList<string>> {
     public StringVectorYankExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 15032)
@@ -15,5 +15,5 @@
     public override void Dispose() {
       base.Dispose();
-      Reset();
+      Clear();
       pool.Free(this);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15032)
@@ -16,4 +16,5 @@
   public class PushInterpreter : IInternalPushInterpreter, IDisposable {
     private Task currentTask;
+    private Expression currentProgram;
 
     public PushInterpreter(IReadOnlyPushConfiguration config = null, IRandom random = null, InterpreterPoolContainer poolContainer = null) {
@@ -23,52 +24,16 @@
       // setting the capacity of the Stacks to max points ensures that there will be enough memory at runtime
       ExecStack = new PushStack<Expression>(Configuration.MaxPointsInProgram);
-
-      CodeStack = new PushStack<Expression> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Code]
-      };
-
-      NameStack = new PushStack<string> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Code]
-      };
-
-      BooleanStack = new PushStack<bool> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Boolean]
-      };
-
-      IntegerStack = new PushStack<long> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Integer]
-      };
-
-      FloatStack = new PushStack<double> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Float]
-      };
-
-      CharStack = new PushStack<char> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Char]
-      };
-
-      StringStack = new PushStack<string> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.String]
-      };
-
-      IntegerVectorStack = new PushStack<IReadOnlyList<long>> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.IntegerVector]
-      };
-
-      FloatVectorStack = new PushStack<IReadOnlyList<double>> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.FloatVector]
-      };
-
-      BooleanVectorStack = new PushStack<IReadOnlyList<bool>> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.BooleanVector]
-      };
-
-      StringVectorStack = new PushStack<IReadOnlyList<string>> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.StringVector]
-      };
-
-      PrintStack = new PushStack<string> {
-        IsEnabled = Configuration.EnabledStacks[StackTypes.Print]
-      };
+      CodeStack = new PushStack<Expression>();
+      NameStack = new PushStack<string>();
+      BooleanStack = new PushStack<bool>();
+      IntegerStack = new PushStack<long>();
+      FloatStack = new PushStack<double>();
+      CharStack = new PushStack<char>();
+      StringStack = new PushStack<string>();
+      IntegerVectorStack = new PushStack<IReadOnlyList<long>>();
+      FloatVectorStack = new PushStack<IReadOnlyList<double>>();
+      BooleanVectorStack = new PushStack<IReadOnlyList<bool>>();
+      StringVectorStack = new PushStack<IReadOnlyList<string>>();
+      PrintStack = new PushStack<string>();
 
       Stacks = new Dictionary<StackTypes, IPushStack> {
@@ -90,4 +55,6 @@
       CustomExpressions = new Dictionary<string, Expression>();
       PoolContainer = poolContainer ?? new InterpreterPoolContainer();
+
+      ConfigureStacks();
     }
 
@@ -187,4 +154,5 @@
     public void Run(Expression expression, bool stepwise = false) {
       IsPaused = stepwise;
+      currentProgram = expression;
 
       /* Push top expression so the loop is able to enter
@@ -267,10 +235,20 @@
     public void Reset() {
       ExecCounter = 0;
-
       IsAborted = false;
       IsPaused = false;
       currentTask = null;
+      currentProgram = null;
 
       Clear();
+      ConfigureStacks();
+    }
+
+    private void ConfigureStacks() {
+      foreach (var pair in this.Stacks) {
+        pair.Value.IsEnabled = Configuration.IsStackEnabled(pair.Key);
+      }
+
+      // exec stack must always be enabled
+      this.ExecStack.IsEnabled = true;
     }
 
@@ -288,6 +266,5 @@
     private void Run() {
       // if no stack which is modifies the exec stack is enabled, unroll loop due to performance reasons
-      if (!Configuration.EnabledStacks[StackTypes.Exec] &&
-          !Configuration.EnabledStacks[StackTypes.Code]) {
+      if (!Configuration.IsStackEnabled(StackTypes.Exec)) {
         while (CanRun(10))
           DoTenSteps();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15032)
@@ -14,5 +14,5 @@
 
     public PushInterpreterPool(IReadOnlyPushConfiguration config = null)
-      : this(Environment.ProcessorCount * 2, 1024, null, config) {
+      : this(Environment.ProcessorCount * 4, 1024, null, config) {
     }
 
@@ -34,4 +34,5 @@
       var interpreter = pool.Allocate();
       interpreter.Random = random ?? new MersenneTwister();
+      interpreter.Reset();
 
       return interpreter;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15032)
@@ -120,5 +120,6 @@
           AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
           CellTemplate = cellTemplate,
-          DefaultCellStyle = { Alignment = DataGridViewContentAlignment.MiddleRight }
+          DefaultCellStyle = { Alignment = DataGridViewContentAlignment.MiddleRight },
+          SortMode = DataGridViewColumnSortMode.Automatic
         };
 
@@ -133,4 +134,5 @@
           AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
           CellTemplate = cellTemplate,
+          SortMode = DataGridViewColumnSortMode.Automatic
         };
 
@@ -138,5 +140,6 @@
           HeaderText = string.Format(OutputHeaderStringFormat, i + 1, headerTypeName),
           AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
-          CellTemplate = cellTemplate
+          CellTemplate = cellTemplate,
+          SortMode = DataGridViewColumnSortMode.Automatic
         };
 
@@ -151,5 +154,6 @@
         HeaderText = AbsoluteDiffHeaderText,
         AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
-        CellTemplate = cellTemplate
+        CellTemplate = cellTemplate,
+        SortMode = DataGridViewColumnSortMode.Automatic
       };
 
@@ -158,4 +162,5 @@
         AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
         CellTemplate = cellTemplate,
+        SortMode = DataGridViewColumnSortMode.Automatic
       };
 
@@ -185,5 +190,5 @@
             var type = data.InputArgumentTypes[j];
             var offset = inputArgumentCountDict[type];
-            row.Cells[j].Value = ViewHelper.StringifyInput(type, offset, example, Separator);
+            row.Cells[j].Value = ViewHelper.StringifyInput(type, offset, Content.Config.FloatStringFormat, example, Separator);
             inputArgumentCountDict[type]++;
           }
@@ -193,5 +198,5 @@
             var type = data.OutputArgumentTypes[j];
             var offset = outputArgumentCountDict[type];
-            row.Cells[data.InputArgumentTypes.Length + j * 2].Value = ViewHelper.StringifyOutput(type, offset, example, Separator);
+            row.Cells[data.InputArgumentTypes.Length + j * 2].Value = ViewHelper.StringifyOutput(type, offset, Content.Config.FloatStringFormat, example, Separator);
             row.Cells[data.InputArgumentTypes.Length + j * 2 + 1].Value = StringifyResult(type, offset, pushInterpreter, example, Separator);
             outputArgumentCountDict[type]++;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15032)
@@ -5,4 +5,5 @@
 
   using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
 
@@ -18,4 +19,9 @@
       Parameters.Add(PushEvaluator.DataParameter);
       Parameters.Add(PushEvaluator.DataBoundsParameter);
+
+      if (PushEvaluator.Data == null) {
+        var defaultProblem = new NumberIO();
+        Load(defaultProblem.CreateProblemData());
+      }
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 15032)
@@ -69,20 +69,22 @@
 
         var expressionType = expression.GetType();
-        close += random.NextBiased(0, config.MaxParenthesesClose, config.ParenthesesCloseBiasLevel);
 
+        if (config.ParenthesesCloseBiasLevel > 0) {
+          close += random.NextBiased(0, config.MaxParenthesesClose, config.ParenthesesCloseBiasLevel);
 
-        // check if expression requires additional blocks
-        if (ExpressionTable.TypeToAttributeTable.ContainsKey(expressionType)) {
-          var attr = ExpressionTable.TypeToAttributeTable[expressionType];
+          // check if expression requires additional blocks
+          if (ExpressionTable.TypeToAttributeTable.ContainsKey(expressionType)) {
+            var attr = ExpressionTable.TypeToAttributeTable[expressionType];
 
-          for (var blockIdx = 0u; blockIdx < attr.ExecIn && currentIndex < vector.Length; blockIdx++) {
-            if (close != 0) {
-              close--;
-              expressions.Add(PushProgram.Empty);
-            } else {
-              currentIndex++;
-              var subProgram = FromPlush(vector, ref currentIndex, ref close, depth + 1, config, random);
-              var subExpression = subProgram.Count == 1 ? subProgram.Expressions[0] : subProgram;
-              expressions.Add(subExpression);
+            for (var blockIdx = 0u; blockIdx < attr.ExecIn && currentIndex < vector.Length; blockIdx++) {
+              if (close != 0) {
+                close--;
+                expressions.Add(PushProgram.Empty);
+              } else {
+                currentIndex++;
+                var subProgram = FromPlush(vector, ref currentIndex, ref close, depth + 1, config, random);
+                var subExpression = subProgram.Count == 1 ? subProgram.Expressions[0] : subProgram;
+                expressions.Add(subExpression);
+              }
             }
           }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15032)
@@ -10,4 +10,5 @@
   using HeuristicLab.Data;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
@@ -40,4 +41,5 @@
       InitParameters();
       InitEncoding();
+      InitOperators();
     }
 
@@ -85,4 +87,5 @@
     private const string InitProgramLengthParameterName = "InitProgramLength";
     private const string InitProgramLengthParameterDescription = "This is the initial size of a push program.";
+    private const string PushConfigurationParameterName = "PushConfiguration";
 
     public const string CasesScopeParameterName = "CaseQualities";
@@ -96,4 +99,9 @@
       }
 
+      if (!Parameters.ContainsKey(PushConfigurationParameterName))
+        Parameters.Add(new ValueParameter<IReadOnlyPushConfiguration>(PushConfigurationParameterName, config) {
+          Hidden = true
+        });
+
       if (!Parameters.ContainsKey(InitProgramLengthParameterName)) {
         Parameters.Add(new FixedValueParameter<IntValue>(
@@ -123,4 +131,8 @@
       Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
       Encoding.Length = config.MaxPointsInProgram;
+    }
+
+    private void InitOperators() {
+      Operators.Add(new PushExpressionFrequencyAnalyzer());
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IPushStackBase.cs	(revision 15032)
@@ -5,5 +5,5 @@
   public interface IPushStack : IEnumerable {
     bool IsEmpty { get; }
-    bool IsEnabled { get; }
+    bool IsEnabled { get; set; }
     int Count { get; }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 15032)
@@ -4,5 +4,5 @@
   // Be aware that it is assumed that this values are equal to HeuristicLab.BenchmarkSuite.DataTypes
   [Flags]
-  public enum StackTypes : ushort {
+  public enum StackTypes {
     None = 0x01, // Required to specify expression dependencies
     Integer = 0x02,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.Designer.cs	(revision 15032)
@@ -46,4 +46,5 @@
       this.expressionsTreeView.Location = new System.Drawing.Point(3, 16);
       this.expressionsTreeView.Name = "expressionsTreeView";
+      this.expressionsTreeView.ShowNodeToolTips = true;
       this.expressionsTreeView.Size = new System.Drawing.Size(321, 436);
       this.expressionsTreeView.TabIndex = 0;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 15032)
@@ -5,5 +5,4 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Views {
-  using System;
   using System.Collections.Generic;
   using System.Linq;
@@ -11,4 +10,5 @@
 
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Stack;
@@ -52,5 +52,5 @@
 
       if (e.Node.Parent == null) {
-        Content.SetStack(stackType, e.Node.Checked, true, false);
+        Content.SetStack(stackType, e.Node.Checked);
         SetStackNodeText(e.Node);
         foreach (var subNode in e.Node.Nodes.OfType<TreeNode>().Where(n => n.Checked != e.Node.Checked))
@@ -62,6 +62,5 @@
         // enable/disable stack if no or at least one expression is enabled
         if ((e.Node.Checked && !e.Node.Parent.Checked) ||
-            (!e.Node.Checked && !e.Node.Parent.Nodes.OfType<TreeNode>().Any(n => n.Checked))) {
-          Content.SetStack(stackType, e.Node.Checked, false, false);
+            (!e.Node.Checked && e.Node.Parent.Nodes.OfType<TreeNode>().All(n => !n.Checked))) {
           e.Node.Parent.Checked = e.Node.Checked;
         }
@@ -90,9 +89,12 @@
       expressionsTreeView.Nodes.Clear();
 
-      var treeNodes = GetTreeNodes(Content.EnabledExpressions).ToArray();
+      var treeNodes = GetTreeNodes(Content.EnabledExpressions)
+        .OrderBy(x => x.Text)
+        .ToArray();
+
       expressionsTreeView.Nodes.AddRange(treeNodes);
     }
 
-    private IEnumerable<TreeNode> GetTreeNodes(IList<string> enabledExpressions) {
+    private IEnumerable<TreeNode> GetTreeNodes(IReadOnlyList<string> enabledExpressions) {
       foreach (var stackType in ExpressionTable.StackTypeToNamesTable.Keys) {
         var stackTreeNode = new TreeNode {
@@ -107,4 +109,10 @@
 
         var expressionNodes = stackExpressions
+          .Where(name => {
+            var type = ExpressionTable.NameToTypeTable[name];
+            var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+            return !attribute.IsHidden;
+          })
           .OrderBy(name => name)
           .Select(name => new TreeNode {
@@ -113,4 +121,11 @@
             Checked = enabledStackExpressions.Contains(name),
           }).ToArray();
+
+        foreach (var node in expressionNodes) {
+          var type = ExpressionTable.NameToTypeTable[node.Text];
+          var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+          node.ToolTipText = attribute.Description;
+        }
 
         stackTreeNode.Nodes.AddRange(expressionNodes);
@@ -121,13 +136,14 @@
 
     private void SetStackNodeText(TreeNode node) {
-      var stackType = (StackTypes)node.Tag;
-      var stackExpressions = ExpressionTable.StackTypeToNamesTable[stackType];
+      var stackTypes = (StackTypes)node.Tag;
+      var stackExpressions = ExpressionTable.StackTypeToNamesTable[stackTypes];
       var enabledStackExpressions = Content.EnabledExpressions.Intersect(stackExpressions).ToList();
+      var stackNames = string.Join(", ", stackTypes.ToValues().Select(type => type.ToString()).OrderBy(x => x));
 
       node.Text = string.Format(
                 "{0} ({1}/{2})",
-                Enum.GetName(typeof(StackTypes), stackType),
+                stackNames,
                 enabledStackExpressions.Count,
-                ExpressionTable.StackTypeToNamesTable[stackType].Count);
+                stackExpressions.Count);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 15032)
@@ -183,17 +183,16 @@
 
       foreach (StackTypes stackType in Enum.GetValues(typeof(StackTypes))) {
-        if (stackType != StackTypes.Exec &&
-            ExpressionTable.GetExpressionsByStackTypes(stackType).Intersect(config.EnabledExpressions).Any()) {
-
-          switch (stackType) {
-            case StackTypes.Code:
-              var treeView = CreatePushProgramTreeView(stackType);
-              debugPushProgramDict.Add(stackType, treeView);
-              break;
-            default:
-              var list = CreateDebugList(stackType);
-              debugListDict.Add(stackType, list);
-              break;
-          }
+        if (stackType == StackTypes.Exec || !config.IsStackEnabled(stackType))
+          continue;
+
+        switch (stackType) {
+          case StackTypes.Code:
+            var treeView = CreatePushProgramTreeView(stackType);
+            debugPushProgramDict.Add(stackType, treeView);
+            break;
+          default:
+            var list = CreateDebugList(stackType);
+            debugListDict.Add(stackType, list);
+            break;
         }
       }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs	(revision 15032)
@@ -13,4 +13,6 @@
     public PushProgramTreeView() {
       InitializeComponent();
+
+      ShowNodeToolTips = true;
     }
 
@@ -28,5 +30,5 @@
       var node = new TreeNode {
         Text = GetNodeText(expression),
-        Tag = expression
+        Tag = expression,
       };
 
@@ -36,4 +38,9 @@
 
         node.Nodes.AddRange(subNodes);
+      } else {
+        var type = expression.GetType();
+        var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+        node.ToolTipText = attribute.Description;
       }
 
